<?php

##### Configuration
###
### Ideally do not change this configuration file.
### Override it in the local configuration file.
### See the file inclusion at the bottom.
###
### Tree location as relative paths to the current location both
### in file system (fs) and (url) space.
### Order is important.
### It is assumed one (and only one) array element has an empty
### key defining the tree where a file not found error will be generated
### by the http daemon in case the file is indeed not found.
### All other trees can be excluded with, e.g.,
### http://www.math.ist.utl.pt/tetexbeta/texmf-dist/doc/texdoc.php?local=no
### http://www.math.ist.utl.pt/tetexbeta/texmf-dist/doc/texdoc.php?dist=no
### End paths with slashes /
### Always start with dist tree so that its section order is preserved
### in case there are missing or extra sections in the other *.dat files.
$texmftrees['fs'] = array( 'dist' => '../../../texmf-dist/' ,
			  '' => '../../../texmf/',
                          'local' => '../../../texmf-local/');
$texmftrees['url'] = array( 'dist' => '../../../texmf-dist/',
			  '' => '../../../texmf/',
			  'local' => '../../../texmf-local/' );
### Support for variable names in the *.dat files.
### One might argue that several names may be admissible
### in each of one or more trees; then values should be arrays
### and code will need to be changed with one more loop.
$texmftrees['datname'] = array( 'local' => 'texdoctk-local.dat',
			  '' => 'texdoctk.dat',
			  'dist' => 'texdoctk.dat' );
### How to invoke kpsewhich; if you have more than one teTeX installation
### use a full path
#$kpsewhich="/usr/local/teTeX/bin/i686-pc-linux-gnu/kpsewhich";
### or if there is no ambiguity
$kpsewhich="kpsewhich";

### Supporting compressed documentation as in Debian.
$zextensions = array( '.bz2' , '.gz' , '' );

### Check for an extra configuration file in the local tree
### redefining the configuration. 

if (file_exists($texmftrees['fs']['local'] . "doc/tdphp/config-local.php"))
{
  include($texmftrees['fs']['local'] . "doc/tdphp/config-local.php");
}

?>
